

%left AND OR NAND NOR XOR XNOR
%left '=' INEQUALITY '<' LESS_THAN_OR_EQUAL '>' GREATER_THAN_OR_EQUAL
%left SLL SRL SLA SRA ROL ROR
%left '+' '-' '&'
%left UNARY_PLUS UNARY_MINUS
%left '*' '/' MOD REM
%left DOUBLESTAR ABS NOT

%token	ACCESS;
%token	AFTER;
%token	ALIAS;
%token	ALL;
%token	ARCHITECTURE;
%token	ARRAY;
%token	ASSERT;
%token	ATTRIBUTE;
%token	BEGIN;
%token	BLOCK;
%token	BODY;
%token	BUFFER;
%token	BUS;
%token	CASE;
%token	COMPONENT;
%token	CONFIGURATION;
%token	CONSTANT;
%token	DISCONNECT;
%token	DOWNTO;
%token	ELSE;
%token	ELSIF;
%token	END;
%token	ENTITY;
%token	EXIT;
%token	FILE;
%token	FOR;
%token	FUNCTION;
%token	GENERATE;
%token	GENERIC;
%token	GROUP;
%token	GUARDED;
%token	IF;
%token	IMPURE;
%token	IN;
%token	INERTIAL;
%token	INOUT;
%token	IS;
%token	LABEL;
%token	LIBRARY;
%token	LINKAGE;
%token	LITERAL;
%token	LOOP;
%token	MAP;
%token	NEW;
%token	NEXT;
%token	NULL;
%token	OF;
%token	ON;
%token	OPEN;
%token	OTHERS;
%token	OUT;
%token	PACKAGE;
%token	PORT;
%token	POSTPONED;
%token	PROCEDURAL;
%token	PROCEDURE;
%token	PROCESS;
%token	PROTECTED;
%token	PURE;
%token	RANGE;
%token	RECORD;
%token	REFERENCE;
%token	REGISTER;
%token	REJECT;
%token	REPORT;
%token	RETURN;
%token	SELECT;
%token	SEVERITY;
%token	SHARED;
%token	SIGNAL;
%token	SUBTYPE;
%token	THEN;
%token	TO;
%token	TRANSPORT;
%token	TYPE;
%token	UNAFFECTED;
%token	UNITS;
%token	UNTIL;
%token	USE;
%token	VARIABLE;
%token	WAIT;
%token	WHEN;
%token	WHILE;
%token	WITH;
%token	DOUBLESTAR;
%token	VARIABLE_ASSIGNMENT;
%token	ARROW;
%token	BOX;
%token	BASIC_IDENTIFIER;
%token	CHARACTER_LITERAL;
%token	ABSTRACT_LITERAL;
%token	BIT_STRING_LITERAL_B;
%token	BIT_STRING_LITERAL_O;
%token	BIT_STRING_LITERAL_X;
%token	EXTENDED_IDENTIFIER;
%token	STRING_LITERAL;


//%token /*__TTT__*/


%token BOGUS


%%

start
	: design_file
//	| library_clause
//	| context_clause
	;



/*#####################################################
  #        Design entities and conﬁgurations          #
  #####################################################*/


/********************************** Entity declarations **********************************/

entity_declaration
	: ENTITY identifier IS
	  entity_header
	  entity_declarative_part
	  entity_declaration_begin_entity_statement_part_optional
	  END entity_optional simple_name_optional ';'
	;

entity_declaration_begin_entity_statement_part_optional
	: //empty
	| BEGIN entity_statement_part
	;


/********** Entity header **********/

entity_header
	: //empty
	| generic_clause
	| port_clause
	| generic_clause port_clause
	;

generic_clause
	: GENERIC '(' generic_list ')' ';'
	;

port_clause
	: PORT '(' port_list ')' ';'
	;


/********** Generics **********/

generic_list
	: interface_list
	;


/********** Ports **********/

port_list
	: interface_list
	;


/********** Entity declarative part **********/

entity_declarative_part
	: //empty
	| entity_declarative_part entity_declarative_item
	;

entity_declarative_item
	: subprogram_declaration
	| subprogram_body
	| type_declaration
	| subtype_declaration
	| constant_declaration
	| signal_declaration
	| variable_declaration
	| file_declaration
	| alias_declaration
	| attribute_declaration
	| attribute_specification
	| disconnection_specification
	| use_clause
	| group_template_declaration
	| group_declaration
	;


/********** Entity statement part **********/

entity_statement_part
	: //empty
	| entity_statement_part entity_statement
	;

entity_statement
	: concurrent_assertion_statement
	| concurrent_procedure_call_statement	// doplněno _statement, protože concurrent_procedure_call neexistuje - zkontrolovat, případně dořešit
	| process_statement
	;



/********************************** Architecture bodies **********************************/

architecture_body
	: ARCHITECTURE identifier OF name IS
		architecture_declarative_part
		BEGIN
			architecture_statement_part
		END architecture_optional simple_name_optional ';'
	;


/********** Architecture declarative part **********/

architecture_declarative_part
	: //empty
	| architecture_declarative_part block_declarative_item
	;

block_declarative_item
	: subprogram_declaration
	| subprogram_body
	| type_declaration
	| subtype_declaration
	| constant_declaration
	| signal_declaration
	| variable_declaration
	| file_declaration
	| alias_declaration
	| component_declaration
	| attribute_declaration
	| attribute_specification
	| configuration_specification
	| disconnection_specification
	| use_clause
	| group_template_declaration
	| group_declaration
	;


/********** Architecture statement part **********/

architecture_statement_part
	: //empty
	| architecture_statement_part concurrent_statement
	;


/********************************** Conﬁguration declarations **********************************/

configuration_declaration
	: CONFIGURATION identifier OF name IS
	  configuration_declarative_part
	  block_configuration
	  END configuration_optional simple_name_optional ';'
	;

configuration_declarative_part
	: //empty
	| configuration_declarative_part configuration_declarative_item
	;

configuration_declarative_item
	: use_clause
	| attribute_specification
	| group_declaration
	;


/********** Block configuration **********/

block_configuration
	: FOR
		block_specification block_configuration_use_clause_iterate block_configuration_configuration_item_iterate
	  END FOR ';'
	;

block_configuration_use_clause_iterate
	: //empty
	| block_configuration_use_clause_iterate use_clause
	;

block_configuration_configuration_item_iterate
	: //empty
	| block_configuration_configuration_item_iterate configuration_item
	;

block_specification
	: name /*__TTT__*/
	| label
	| label '(' index_specification ')'
	;

index_specification
	: discrete_range
	| expression
	;

configuration_item
	: block_configuration
	| component_configuration
	;


/********** Component configuration **********/

component_configuration
	: FOR component_specification
	  component_configuration_binding_indication_optional
	  component_configuration_block_configuration_optional
	  END FOR ';'
	;

component_configuration_binding_indication_optional
 : // empty
	| binding_indication ';'
	;

component_configuration_block_configuration_optional
 : // empty
	| block_configuration
	;



/*#####################################################
  #              Subprograms and packages             #
  #####################################################*/


/********************************** Subprogram declarations **********************************/

subprogram_declaration
	: subprogram_specification ';'
	;

subprogram_specification
	: PROCEDURE designator
	| PROCEDURE designator '(' formal_parameter_list ')'
	| subprogram_specification_pure_impure_optional FUNCTION designator RETURN type_mark
	| subprogram_specification_pure_impure_optional FUNCTION designator '(' formal_parameter_list ')' RETURN type_mark
	;

subprogram_specification_pure_impure_optional
	: //empty
	| PURE
	| IMPURE
	;

designator
	: identifier
	| operator_symbol
	;

operator_symbol
	: STRING_LITERAL
	;


/********** Formal parameters **********/

formal_parameter_list
	: interface_list
	;


/********** Subprogram bodies **********/

subprogram_body
	: subprogram_specification IS
	  subprogram_declarative_part
	  BEGIN
	  subprogram_statement_part
	  END subprogram_body_subprogram_optional ';'
	;

subprogram_body_subprogram_optional
	: //empty
	| subprogram_kind
	| designator
	| subprogram_kind designator
	;

subprogram_declarative_part
	: //empty
	| subprogram_declarative_part subprogram_declarative_item
	;

subprogram_declarative_item
	: subprogram_declaration
	| subprogram_body
	| type_declaration
	| subtype_declaration
	| constant_declaration
	| variable_declaration
	| file_declaration
	| alias_declaration
	| attribute_declaration
	| attribute_specification
	| use_clause
	| group_template_declaration
	| group_declaration
	;

subprogram_statement_part
	: //empty
	| subprogram_statement_part sequential_statement
	;

subprogram_kind
	: PROCEDURE
	| FUNCTION
	;


/********************************** Subprogram overloading **********************************/

/********** Signatures **********/

signature
	: '[' ']'
	| '[' signature_type_mark_iterate ']'
	| '[' RETURN type_mark ']'
	| '[' signature_type_mark_iterate RETURN type_mark ']'
	;

signature_type_mark_iterate
	: type_mark
	| signature_type_mark_iterate ',' type_mark
	;


/********************************** Package declarations **********************************/

package_declaration
	: PACKAGE identifier IS
	  package_declarative_part
	  END package_optional simple_name_optional ';'
	;

package_declarative_part
	: //empty
	| package_declarative_part package_declarative_item
	;

package_declarative_item
	: subprogram_declaration
	| type_declaration
	| subtype_declaration
	| constant_declaration
	| signal_declaration
	| variable_declaration
	| file_declaration
	| alias_declaration
	| component_declaration
	| attribute_declaration
	| attribute_specification
	| disconnection_specification
	| use_clause
	| group_template_declaration
	| group_declaration
	;


/********************************** Package bodies **********************************/

package_body
	: PACKAGE BODY simple_name IS
	  package_body_declarative_part
	  END package_body_package_body_optional simple_name_optional ';'
	;

package_body_package_body_optional
	: //empty
	| PACKAGE BODY
	;

package_body_declarative_part
	: //empty
	| package_body_declarative_part package_body_declarative_item
	;

package_body_declarative_item
	: subprogram_declaration
	| subprogram_body
	| type_declaration
	| subtype_declaration
	| constant_declaration
	| variable_declaration
	| file_declaration
	| alias_declaration
	| use_clause
	| group_template_declaration
	| group_declaration
	;



/*#####################################################
  #                       Types                       #
  #####################################################*/


/********************************** Scalar types **********************************/

scalar_type_definition
	: enumeration_type_definition
	| range_constraint
	| physical_type_definition
	;

range_constraint
	: RANGE range
	;

range
	: attribute_name /*__TTT__*/
	| simple_expression direction simple_expression
	;

direction
	: TO
	| DOWNTO
	;



/********** Enumeration types **********/

enumeration_type_definition
	: '(' enumeration_type_definition_iterate ')'
	;

enumeration_type_definition_iterate
	: enumeration_literal
	| enumeration_type_definition_iterate ',' enumeration_literal
	;

enumeration_literal
	: identifier
	| CHARACTER_LITERAL
	;


/********** Physical types **********/

physical_type_definition
	: range_constraint
	  UNITS
		primary_unit_declaration
		physical_type_definition_secondary_unit_declaration_iterate
	  END UNITS simple_name_optional
	;

primary_unit_declaration
	: identifier ';'
	;

physical_type_definition_secondary_unit_declaration_iterate
	: //empty
	| physical_type_definition_secondary_unit_declaration_iterate secondary_unit_declaration
	;

secondary_unit_declaration
	: identifier '=' physical_literal ';'
	;

physical_literal
	: name /*__TTT__*/
	| ABSTRACT_LITERAL name /*__TTT__*/
	;


/********************************** Composite types **********************************/

composite_type_definition
	: array_type_definition
	| record_type_definition
	;


/********** Array types **********/

array_type_definition
	: unconstrained_array_definition
	| constrained_array_definition
	;

unconstrained_array_definition
	: ARRAY '(' unconstrained_array_definition_index_subtype_definition_iterate ')'
	  OF subtype_indication
	;

unconstrained_array_definition_index_subtype_definition_iterate
	: index_subtype_definition
	| unconstrained_array_definition_index_subtype_definition_iterate ',' index_subtype_definition
	;

constrained_array_definition
	: ARRAY index_constraint OF subtype_indication
	;

index_subtype_definition
	: type_mark RANGE BOX
	;

index_constraint
	: '(' index_constraint_discrete_range_iterate ')'
	;

index_constraint_discrete_range_iterate
	: discrete_range
	| index_constraint_discrete_range_iterate ',' discrete_range
	;

discrete_range
	: subtype_indication
//	| range // Na range nelze jít, přepisuje se na attribute_name, na které se přepisuje i name, takže další R/R
	| simple_expression direction simple_expression // Tohle je druhá cesta z range, takže si ju místo něj přidáme...
	;


/********** Record types **********/

record_type_definition
	: RECORD
	    element_declaration
	    record_type_definition_element_declaration_iterate
	  END RECORD simple_name_optional
	;

record_type_definition_element_declaration_iterate
	: //empty
	| record_type_definition_element_declaration_iterate element_declaration
	;

element_declaration
	: identifier_list ':' element_subtype_definition ';'
	;

identifier_list
	: identifier
	| identifier_list ',' identifier
	;

element_subtype_definition
	: subtype_indication
	;



/********************************** Access types **********************************/

access_type_definition
	: ACCESS subtype_indication
	;


/********** Incomplete type declarations **********/

incomplete_type_declaration
	: TYPE identifier ';'
	;



/********************************** File types **********************************/

file_type_definition
	: FILE OF type_mark
	;



/********************************** Protected types **********************************/

protected_type_definition
	: protected_type_declaration
	| protected_type_body
	;


/********** Protected type declarations **********/

protected_type_declaration
	: PROTECTED
	    protected_type_declarative_part
	  END PROTECTED simple_name_optional
	;

protected_type_declarative_part
	: //empty
	| protected_type_declarative_part protected_type_declarative_item
	;

protected_type_declarative_item
	: subprogram_declaration		// tak tady se liší zápis na straně 50 standardu od strany 231. Co je správně?
	| attribute_specification
	| use_clause
	;


/********** Protected type bodies **********/

protected_type_body
	: PROTECTED BODY
	    protected_type_body_declarative_part
	  END PROTECTED BODY simple_name_optional	// Doplněno podtržítko, simple ani name samostatně neexistují :-(
	;

protected_type_body_declarative_part
	: //empty
	| protected_type_body_declarative_part protected_type_body_declarative_item
	;

protected_type_body_declarative_item
	: subprogram_declaration
	| subprogram_body
	| type_declaration
	| subtype_declaration
	| constant_declaration
	| variable_declaration
	| file_declaration
	| alias_declaration
	| attribute_declaration
	| attribute_specification
	| use_clause
	| group_template_declaration
	| group_declaration
	;





/*#####################################################
  #                   Declarations                    #
  #####################################################*/


/*declaration		Zatím zakoentováno. Useles rule?
	: type_declaration
	| subtype_declaration
	| object_declaration
	| interface_declaration
	| alias_declaration
	| attribute_declaration
	| component_declaration
	| group_template_declaration
	| group_declaration
	| entity_declaration
	| configuration_declaration
	| subprogram_declaration
	| package_declaration
	| primary_unit
	| architecture_body
	;*/


/********************************** Type declarations **********************************/

type_declaration
	: full_type_declaration
	| incomplete_type_declaration
	;

full_type_declaration
	: TYPE identifier IS type_definition ';'
	;

type_definition
	: scalar_type_definition
	| composite_type_definition
	| access_type_definition
	| file_type_definition
	| protected_type_definition
	;


/********************************** Subtype declarations **********************************/

subtype_declaration
	: SUBTYPE identifier IS subtype_indication ';'
	;

subtype_indication
	: name
	| name name
	| name constraint	// na constraint vzniká nechutná nepřímá rekurze....
	| name name constraint
	;

/*subtype_indication
	: type_mark
	| name type_mark
	| type_mark constraint
	| name type_mark constraint
	;*/

type_mark	// nelze eliminovat, používá se i jinde
	: name /*__TTT__*/
//	| name /*__TTT__*/
	;

constraint
	: range_constraint
	| index_constraint
	;


/********************************** Objects **********************************/


/********** Object declarations **********/

/*object_declaration		// Useless rule?
	: constant_declaration
	| signal_declaration
	| variable_declaration
	| file_declaration
	;*/

constant_declaration
	: CONSTANT identifier_list ':' subtype_indication ';'
	| CONSTANT identifier_list ':' subtype_indication VARIABLE_ASSIGNMENT expression ';'
	;

signal_declaration
	: SIGNAL identifier_list ':' subtype_indication ';'
	| SIGNAL identifier_list ':' subtype_indication signal_kind ';'
	| SIGNAL identifier_list ':' subtype_indication VARIABLE_ASSIGNMENT expression ';'
	| SIGNAL identifier_list ':' subtype_indication signal_kind VARIABLE_ASSIGNMENT expression ';'
	;

signal_kind
	: REGISTER
	| BUS
	;

variable_declaration
	: VARIABLE identifier_list ':' subtype_indication ';'
	| SHARED VARIABLE identifier_list ':' subtype_indication ';'
	| VARIABLE identifier_list ':' subtype_indication VARIABLE_ASSIGNMENT expression ';'
	| SHARED VARIABLE identifier_list ':' subtype_indication VARIABLE_ASSIGNMENT expression ';'
	;

file_declaration
	: FILE identifier_list ':' subtype_indication ';'
	| FILE identifier_list ':' subtype_indication file_open_information ';'
	;

file_open_information
	: IS file_logical_name
	| OPEN expression IS file_logical_name
	;

file_logical_name
	: expression
	;


/********** Interface declarations **********/

interface_declaration
	: CONSTANT constant_if_decl
	| SIGNAL signal_if_decl
	| VARIABLE variable_if_decl
	| identifier_list ':' IN subtype_indication if_decl_var_assign_optional
	| identifier_list ':' mode subtype_indication if_decl_next
	| identifier_list ':' subtype_indication
	;

constant_if_decl
	: identifier_list ':' subtype_indication if_decl_var_assign_optional
	: identifier_list ':' IN subtype_indication if_decl_var_assign_optional
	;

signal_if_decl
	: identifier_list ':' subtype_indication if_decl_var_assign_optional
	| identifier_list ':' mode subtype_indication if_decl_var_assign_optional
	| identifier_list ':' subtype_indication BUS if_decl_var_assign_optional
	| identifier_list ':' mode subtype_indication BUS if_decl_var_assign_optional
	;

variable_if_decl
	: identifier_list ':' subtype_indication if_decl_var_assign_optional
	| identifier_list ':' mode subtype_indication if_decl_var_assign_optional
	;

if_decl_next
	: if_decl_var_assign_optional
	| BUS if_decl_var_assign_optional
	;

if_decl_var_assign_optional
	: //empty
	| VARIABLE_ASSIGNMENT expression
	;




//@@@@@@@@@@@@@@@@ -- řešení R/R konfliktu - viz pravidla pro interface_declaration výše, původní je zde zakomentováno
/*interface_declaration
	: interface_constant_declaration
	| interface_signal_declaration
	| interface_variable_declaration
	| interface_file_declaration
	;

interface_constant_declaration
	: interface_constant_declaration_constant_optional identifier_list ':'
	  interface_constant_declaration_in_optional subtype_indication
	  interface_constant_declaration_colon_equal_expression_optional
	;

interface_constant_declaration_constant_optional
	: //empty
	| CONSTANT
	;

interface_constant_declaration_in_optional
	: //empty
	| IN
	;

interface_constant_declaration_colon_equal_expression_optional
	: //empty
	| VARIABLE_ASSIGNMENT expression
	;

interface_signal_declaration
	: interface_signal_declaration_signal_optional identifier_list ':'
	  interface_signal_declaration_mode_optional
	  subtype_indication interface_signal_declaration_bus_optional
	  interface_signal_declaration_colon_equal_expression_optional
	;

interface_signal_declaration_signal_optional
	: //empty
	| SIGNAL
	;

interface_signal_declaration_mode_optional
	: //empty
	| mode
	;

interface_signal_declaration_bus_optional
	: //empty
	| BUS
	;

interface_signal_declaration_colon_equal_expression_optional
	: //empty
	| VARIABLE_ASSIGNMENT expression
	;

interface_variable_declaration
	: interface_variable_declaration_variable_optional identifier_list ':'
	  interface_variable_declaration_mode_optional
	  subtype_indication interface_variable_declaration_colon_equal_expression_optional
	;

interface_variable_declaration_variable_optional
	: //empty
	| VARIABLE
	;

interface_variable_declaration_mode_optional
	: //empty
	| mode
	;

interface_variable_declaration_colon_equal_expression_optional
	: //empty
	| VARIABLE_ASSIGNMENT expression
	;*/
//@@@@@@@@@@@@@@@@

/*interface_file_declaration		// Useles rule?
	: FILE identifier_list ':' subtype_indication
	;*/

mode
	: IN
	| OUT
	| INOUT
	| BUFFER
	| LINKAGE
	;

interface_list
	: interface_element
	| interface_list ';' interface_element
	;

interface_element
	: interface_declaration
	;

association_list
	: association_element
	| association_list ',' association_element
	;

association_element	// jediné použití actual_part i formal_part
	: expression
	| name
	| name '(' expression ')'
	| name '(' OPEN ')'
	| name '(' name ')'
	| name '(' name ')' ARROW actual_part
	| name ARROW actual_part
	;

/*association_element
	: actual_part
	| formal_part ARROW actual_part
	;

formal_part
	: formal_designator
	| name __TTT__ '(' formal_designator ')'
	| type_mark '(' formal_designator ')'
	;

formal_designator
	: name __TTT__
	| name __TTT__
	| name __TTT__
	;*/

actual_part
	: expression
	| name
	| name '(' expression ')'
	| name '(' name ')'
	| name '(' OPEN ')'
	| OPEN
	;

/*actual_part
	: actual_designator
	| name __TTT__ '(' actual_designator ')'
	| type_mark '(' actual_designator ')'
	;

actual_designator
	: expression
	| name __TTT__
	| name __TTT__
	| name __TTT__
	| OPEN
	;*/



/********************************** Alias declarations **********************************/

alias_declaration
	: ALIAS alias_designator alias_declaration_subtype_indication_optional IS name
	  alias_declaration_signature_optional ';'
	;

alias_declaration_subtype_indication_optional
	: //empty
	| ':' subtype_indication
	;

alias_declaration_signature_optional
	: //empty
	| signature
	;

alias_designator
	: identifier
	| CHARACTER_LITERAL
	| operator_symbol
	;



/********************************** Attribute declarations **********************************/

attribute_declaration
	: ATTRIBUTE identifier ':' type_mark ';'
	;



/********************************** Component declarations **********************************/

component_declaration
	: COMPONENT identifier is_optional
	  component_declaration_generic_clause_optional
	  component_declaration_port_clause_optional
	  END COMPONENT simple_name_optional ';'
	;

component_declaration_generic_clause_optional
	: //empty
	| generic_clause
	;

component_declaration_port_clause_optional
	: //empty
	| port_clause
	;



/********************************** Group template declarations **********************************/

group_template_declaration
	: GROUP identifier IS '(' entity_class_entry_list ')' ';'
	;

entity_class_entry_list
	: entity_class_entry
	| entity_class_entry_list ',' entity_class_entry
	;

entity_class_entry
	: entity_class BOX
	| entity_class
	;



/********************************** Group declarations **********************************/

group_declaration
	: GROUP identifier ':' name '(' group_constituent_list ')' ';'
	;

group_constituent_list
	: group_constituent
	| group_constituent_list ',' group_constituent
	;

group_constituent
	: name
	| CHARACTER_LITERAL
	;





/*#####################################################
  #                  Specifications                   #
  #####################################################*/


/********************************** Attribute specification **********************************/

attribute_specification
	: ATTRIBUTE attribute_designator OF entity_specification IS expression ';'
	;

entity_specification
	: entity_name_list ':' entity_class
	;

entity_class
	: ENTITY
	| ARCHITECTURE
	| CONFIGURATION
	| PROCEDURE
	| FUNCTION
	| PACKAGE
	| TYPE
	| SUBTYPE
	| CONSTANT
	| SIGNAL
	| VARIABLE
	| COMPONENT
	| LABEL
	| LITERAL
	| UNITS
	| GROUP
	| FILE
	;

entity_name_list
	: entity_name_list_entity_designator_iterate
	| OTHERS
	| ALL
	;

entity_name_list_entity_designator_iterate
	: entity_designator
	| entity_name_list_entity_designator_iterate ',' entity_designator
	;

entity_designator
	: entity_tag
	| entity_tag signature
	;

entity_tag
	: simple_name
	| CHARACTER_LITERAL
	| operator_symbol
	;



/********************************** Configuration specification **********************************/

configuration_specification
	: FOR component_specification binding_indication ';'
	;

component_specification
	: instantiation_list ':' name
	;

instantiation_list
	: instantiation_list_instantiation_label_iterate
	| OTHERS
	| ALL
	;

instantiation_list_instantiation_label_iterate
	: label
	| instantiation_list_instantiation_label_iterate ',' label
	;


/********** Binding indication **********/

binding_indication
	: binding_indication_use_entity_aspect_optional
	  binding_indication_generic_map_aspect_optional
	  binding_indication_port_map_aspect_optional
	;

binding_indication_use_entity_aspect_optional
	: //empty
	| USE entity_aspect
	;

binding_indication_generic_map_aspect_optional
	: //empty
	| generic_map_aspect
	;

binding_indication_port_map_aspect_optional
	: //empty
	| port_map_aspect
	;

entity_aspect
	: ENTITY name
	| ENTITY name '(' identifier ')'
	| CONFIGURATION name
	| OPEN
	;

generic_map_aspect
	: GENERIC MAP '(' association_list ')'
	;

port_map_aspect
	: PORT MAP '(' association_list ')'
	;



/********************************** Disconnection specification **********************************/

disconnection_specification
	: DISCONNECT guarded_signal_specification AFTER expression ';'
	;

guarded_signal_specification
	: signal_list ':' type_mark
	;

signal_list
	: signal_list_signal_name_iterate
	| OTHERS
	| ALL
	;

signal_list_signal_name_iterate
	: name
	| signal_list_signal_name_iterate ',' name
	;





/*#####################################################
  #                       Names                       #
  #####################################################*/


/********************************** Names **********************************/

name
	: simple_name
	| operator_symbol
	| selected_name
	| indexed_name
	| slice_name
	| attribute_name
	;

prefix
//	: name
	: function_call
	;



/********************************** Simple names **********************************/

simple_name
	: identifier
	;



/********************************** Selected names **********************************/

selected_name
	: prefix '.' suffix
	;

suffix
	: simple_name
	| CHARACTER_LITERAL
	| operator_symbol
	| ALL
	;



/********************************** Indexed names **********************************/

indexed_name
	: prefix '(' indexed_name_expression_iterate ')'
	;

indexed_name_expression_iterate
	: expression
	| indexed_name_expression_iterate ',' expression
	;



/********************************** Slice names **********************************/

slice_name
	: prefix '(' discrete_range ')'
	;



/********************************** Attribute names **********************************/

attribute_name
	: prefix attribute_name_signature_optional '\'' attribute_designator attribute_name_expression_optional
	;

attribute_name_signature_optional
	: //empty
	| signature
	;

attribute_designator
	: simple_name
	;

attribute_name_expression_optional
	: //empty
	| '(' expression ')'
	;





/*#####################################################
  #                    Expressions                    #
  #####################################################*/


/********************************** Expressions **********************************/

expression
	: relation AND expression_and_relation_iterate
	| relation OR expression_or_relation_iterate
	| relation XOR expression_xor_relation_iterate
	| relation NAND relation
	| relation NOR relation
	| relation XNOR expression_xnor_relation_iterate
	| relation
	;

expression_and_relation_iterate
	: relation
	| expression_and_relation_iterate AND relation
	;

expression_or_relation_iterate
	: relation
	| expression_or_relation_iterate OR relation
	;

expression_xor_relation_iterate
	: relation
	| expression_xor_relation_iterate XOR relation
	;

expression_xnor_relation_iterate
	: relation
	| expression_xnor_relation_iterate XNOR relation
	;

relation
	: shift_expression
	| shift_expression relational_operator shift_expression
	;

shift_expression
	: simple_expression
	| simple_expression shift_operator simple_expression
	;

simple_expression
	: term simple_expression_adding_operator_term_iterate
	| sign term simple_expression_adding_operator_term_iterate
	;

simple_expression_adding_operator_term_iterate
	: //empty
	| simple_expression_adding_operator_term_iterate adding_operator term
	;

term
	: factor
	| term multiplying_operator factor
	;

factor
	: primary
	| primary DOUBLESTAR primary
	| ABS primary
	| NOT primary
	;

primary
//	: name	// R/R - konflikt - na čisté name se dostaneme přes function_call
//	| literal // R/R - konflikt, literal lze postupně přepsat na name, takže si vytáhneme všechno zajímavé z literal a zrušíme ho...
	: CHARACTER_LITERAL
	| BIT_STRING_LITERAL_B
	| BIT_STRING_LITERAL_O
	| BIT_STRING_LITERAL_X
	| NULL
	| ABSTRACT_LITERAL
	| ABSTRACT_LITERAL name		// postupně přes numeric literal z literal...

	| aggregate

	| function_call
	| qualified_expression
//	| type_conversion // R/R, protože type_conversion je syntakticky shodná s voláním funkce s jedním parametrem
	| allocator
	| '(' expression ')' // zde možná je R/R, protože toto pravidlo je již obsaženo v aggregate s jedním výrazem, ale bisonovi to nějak nevadí...
	;



/********************************** Operators **********************************/

/*logical_operator		// Useless nonterminal?
	: AND
	| OR
	| NAND
	| NOR
	| XOR
	| XNOR
	;*/

relational_operator
	: '='
	| INEQUALITY
	| '<'
	| LESS_THAN_OR_EQUAL
	| '>'
	| GREATER_THAN_OR_EQUAL
	;

shift_operator
	: SLL
	| SRL
	| SLA
	| SRA
	| ROL
	| ROR
	;

adding_operator
	: '+'
	| '-'
	| '&'
	;

sign
	: '+' %prec UNARY_PLUS
	| '-' %prec UNARY_MINUS
	;

multiplying_operator
	: '*'
	| '/'
	| MOD
	| REM
	;

/*miscellaneous_operator		// Useless nonterminal?
	: DOUBLESTAR
	| ABS
	| NOT
	;*/



/********************************** Operands **********************************/

/********** Literals **********/

/*literal		// Nakonec úplně zrušeno, jediné použití bylo v primary...
	: numeric_literal
//	| enumeration_literal	// Nesmí se odkomentovat - viz další komentář!!!!!!
	| CHARACTER_LITERAL	// Zde bylo pravidlo pro přepis na enumeration_literal, ale ten se dále přepisuje na identifier nebo CHARACTER_LITERAL. Díky tomu vzniká R/R konflikt, kdy se identifier může redukovat na primary přes name i přes literal s naprosto stejným lookaheadem. Vzhledem k tomu, že literal se dále redukuje pouze na primary, bylo pravidlo pro přepis na enumerration_literal nahrazeno pravidlem pouze pro přepis na CHARACTER_LITERAL. Přepis na identifier je tak možný pouze přes NT name, čímž bylo odstraněno 50 R/R konfliktů a zároveň zůstal nedotčený NT enumeration_literal, který se vyskytuje ve více pravidlech.
//	| STRING_LITERAL	// Totéž jako v případě enumeration literal. STRING_LITERAL by opět bylo možné nejednoznačně redukovat na primary přes name i přes literal...
	| BIT_STRING_LITERAL_B
	| BIT_STRING_LITERAL_O
	| BIT_STRING_LITERAL_X
	| NULL
	;*/

/*numeric_literal		// jediné použití bylo v literal...
	: ABSTRACT_LITERAL
	| physical_literal
	;*/


/********** Aggregates **********/

aggregate
	: '(' aggregate_element_association_iterate ')'
	;

aggregate_element_association_iterate
	: element_association
	| aggregate_element_association_iterate ',' element_association
	;

element_association
	: expression
	| choices ARROW expression
	;

choices
	: choice
	| choices '|' choice
	;

choice
	: simple_expression
	| discrete_range
//	| simple_name /*__TTT__*/ // na simple name se dá dlouhou derivací derivovat simple_expression
	| OTHERS
	;


/********** Function calls **********/

function_call
	: name /*__TTT__*/
	| name /*__TTT__*/ '(' actual_parameter_part ')'
	;

actual_parameter_part
	: association_list
	;


/********** Qualified expressions **********/

qualified_expression
	: type_mark '\'' '(' expression ')'
//	| type_mark '\'' aggregate
	;


/********** Type conversions **********/

/*type_conversion		// Jediné použití bylo v primary a tam jsem ho zrušil...
	: type_mark '(' expression ')'
	;*/


/********** Allocators **********/

allocator
	: NEW subtype_indication
	| NEW qualified_expression
	;





/*#####################################################
  #               Sequential statements               #
  #####################################################*/


sequence_of_statements
	: //empty
	| sequence_of_statements sequential_statement
	;

sequential_statement
	: wait_statement
	| assertion_statement
	| report_statement
	| signal_assignment_statement
	| variable_assignment_statement
	| procedure_call_statement
	| if_statement
	| case_statement
	| loop_statement
	| next_statement
	| exit_statement
	| return_statement
	| null_statement
	;



/********************************** Wait statement **********************************/

wait_statement
	: wait_statement_label_colon_optional WAIT wait_statement_sensitivity_clause_optional
	  wait_statement_condition_clause_optional wait_statement_timeout_clause_optional ';'
	;

wait_statement_label_colon_optional
	: //empty
	| label ':'
	;

wait_statement_sensitivity_clause_optional
	: //empty
	| sensitivity_clause
	;

wait_statement_condition_clause_optional
	: //empty
	| condition_clause
	;

wait_statement_timeout_clause_optional
	: //empty
	| timeout_clause
	;

sensitivity_clause
	: ON sensitivity_list
	;

sensitivity_list
	: name
	| sensitivity_list ',' name
	;

condition_clause
	: UNTIL condition
	;

condition
	: expression
	;

timeout_clause
	: FOR expression
	;



/********************************** Assertion statement **********************************/

assertion_statement
	: assertion_statement_label_colon_optional assertion ';'
	;

assertion_statement_label_colon_optional
	: //empty
	| label ':'
	;

assertion
	: ASSERT condition assertion_report_expression_optional assertion_severity_expression_optional
	;
assertion_report_expression_optional
	: //empty
	| REPORT expression
	;

assertion_severity_expression_optional
	: //empty
	| SEVERITY expression
	;



/********************************** Report statement **********************************/

report_statement
	: REPORT expression ';'
	| label ':' REPORT expression ';'
	| REPORT expression SEVERITY expression ';'
	| label ':' REPORT expression SEVERITY expression ';'
	;



/********************************** Signal assignment statement **********************************/

signal_assignment_statement
	: target LESS_THAN_OR_EQUAL waveform ';'
	| label ':' target LESS_THAN_OR_EQUAL waveform ';'
	| target LESS_THAN_OR_EQUAL delay_mechanism waveform ';'
	| label ':' target LESS_THAN_OR_EQUAL delay_mechanism waveform ';'
	;

delay_mechanism
	: TRANSPORT
	| INERTIAL
	| REJECT expression INERTIAL
	;

target
	: name
	| aggregate
	;

waveform
	: waveform_waveform_element_iterate
	| UNAFFECTED
	;

waveform_waveform_element_iterate
	: waveform_element
	| waveform_waveform_element_iterate ',' waveform_element
	;


/********** Updating a projected output waveform **********/

waveform_element
	: expression
	| expression AFTER expression
//	| NULL	// R/R konflikt s pravidlem literal -> NULL - expression lze přímo přepsat na literal
//	| NULL AFTER expression
	;



/********************************** Variable assignment statement **********************************/

variable_assignment_statement
	: target VARIABLE_ASSIGNMENT expression ';'
	| label ':' target VARIABLE_ASSIGNMENT expression ';'
	;



/********************************** procedure call statement **********************************/

procedure_call_statement
	: procedure_call ';'
	| label ':' procedure_call ';'
	;

procedure_call
	: name
	| name '(' actual_parameter_part ')'
	;



/********************************** If statement **********************************/

if_statement
	: if_statement_label_colon_optional
	  IF condition THEN
	    sequence_of_statements
	  if_statement_elsif_iterate
	  if_statement_else_optional
	  END IF if_statement_label_optional ';'
	;

if_statement_label_colon_optional
	: //empty
	| label ':'
	;

if_statement_elsif_iterate
	: //empty
	| if_statement_elsif_iterate ELSIF condition THEN sequence_of_statements
	;

if_statement_else_optional
	: //empty
	| ELSE sequence_of_statements
	;

if_statement_label_optional
	: //empty
	| label
	;



/********************************** Case statement **********************************/

case_statement
	: case_statement_label_colon_optional
	  CASE expression IS
	    case_statement_case_statement_alternative_iterate
	  END CASE case_statement_label_optional ';'
	;

case_statement_label_colon_optional
	: //empty
	| label ':'
	;

case_statement_case_statement_alternative_iterate
	: case_statement_alternative
	| case_statement_case_statement_alternative_iterate case_statement_alternative
	;

case_statement_label_optional
	: //empty
	| label
	;

case_statement_alternative
	: WHEN choices ARROW sequence_of_statements
	;



/********************************** Loop statement **********************************/

loop_statement
	: loop_statement_label_colon_optional loop_statement_iteration_scheme_optional LOOP
	  sequence_of_statements END LOOP loop_statement_label_optional ';'
	;

loop_statement_label_colon_optional
	: //empty
	| label ':'
	;

loop_statement_iteration_scheme_optional
	: //empty
	| iteration_scheme
	;

loop_statement_label_optional
	: //empty
	| label
	;

iteration_scheme
	: WHILE condition
	| FOR parameter_specification
	;

parameter_specification
	: identifier IN discrete_range
	;



/********************************** Next statement **********************************/

next_statement
	: next_statement_label_colon_optional NEXT next_statement_label_optional
	  next_statement_when_condition_optional ';'
	;

next_statement_label_colon_optional
	: //empty
	| label ':'
	;

next_statement_label_optional
	: //empty
	| label
	;

next_statement_when_condition_optional
	: //empty
	| WHEN condition
	;



/********************************** Exit statement **********************************/

exit_statement
	: exit_statement_label_colon_optional EXIT exit_statement_label_optional
	  exit_statement_when_condition_optional ';'
	;

exit_statement_label_colon_optional
	: //empty
	| label ':'
	;

exit_statement_label_optional
	: //empty
	| label
	;

exit_statement_when_condition_optional
	: //empty
	| WHEN condition
	;



/********************************** Return statement **********************************/

return_statement
	: RETURN ';'
	| label ':' RETURN ';'
	| RETURN expression ';'
	| label ':' RETURN expression ';'
	;



/********************************** Null statement **********************************/

null_statement
	: NULL ';'
	| label ':' NULL ';'
	;





/*#####################################################
  #               Concurrent statements               #
  #####################################################*/



concurrent_statement
	: block_statement
	| process_statement
	| concurrent_procedure_call_statement
	| concurrent_assertion_statement
	| concurrent_signal_assignment_statement
	| component_instantiation_statement
	| generate_statement
	;



/********************************** Block statement **********************************/

block_statement
	: label ':'
	    BLOCK block_statement_expression_optional is_optional
	      block_header
	      block_declarative_part
	    BEGIN
		  block_statement_part
	    END BLOCK block_statement_label_optional ';'
	;

block_statement_expression_optional
	: //empty
	|	'(' expression ')'
	;

block_statement_label_optional
	: //empty
	|	label
	;

block_header
	: block_header_first_optional block_header_second_optional
	;

block_header_first_optional
 : // empty
	| generic_clause
	| generic_clause generic_map_aspect ';'
	;

block_header_second_optional
	: //empty
	| port_clause
	| port_clause port_map_aspect ';'
	;

block_declarative_part
	: //empty
	| block_declarative_part block_declarative_item
	;

block_statement_part
	: //empty
	| block_statement_part concurrent_statement
	;



/********************************** Process statement **********************************/

process_statement
	: process_statement_label_colon_optional
	    postponed_optional PROCESS process_statement_sensitivity_list_optional is_optional
	      process_declarative_part
	    BEGIN
	      process_statement_part
		END postponed_optional PROCESS process_statement_label_optional ';'
	;

process_statement_label_colon_optional
	: //empty
	| label ':'
	;

process_statement_sensitivity_list_optional
	: //empty
	| '(' sensitivity_list ')'
	;

process_statement_label_optional
	: //empty
	| label
	;

process_declarative_part
	: //empty
	| process_declarative_part process_declarative_item
	;

process_declarative_item
	: subprogram_declaration
	| subprogram_body
	| type_declaration
	| subtype_declaration
	| constant_declaration
	| variable_declaration
	| file_declaration
	| alias_declaration
	| attribute_declaration
	| attribute_specification
	| use_clause
	| group_template_declaration
	| group_declaration
	;

process_statement_part
	: //empty
	| process_statement_part sequential_statement
	;



/********************************** Concurrent procedure call statements **********************************/

concurrent_procedure_call_statement
	: postponed_optional procedure_call ';'
	| label ':' postponed_optional procedure_call ';'
	;



/********************************** Concurrent assertion statements **********************************/

concurrent_assertion_statement
	: postponed_optional assertion ';'
	| label ':' postponed_optional assertion ';'
	;



/********************************** Concurrent signal assignment statements **********************************/

concurrent_signal_assignment_statement
	: postponed_optional conditional_signal_assignment
	| label ':' postponed_optional conditional_signal_assignment
	| postponed_optional selected_signal_assignment
	| label ':' postponed_optional selected_signal_assignment
	;

options
	: //empty
	| GUARDED
	| delay_mechanism
	| GUARDED delay_mechanism
	;


/********** Conditional signal assignments **********/

conditional_signal_assignment
	: target LESS_THAN_OR_EQUAL options conditional_waveforms ';'
	;

conditional_waveforms
	: conditional_waveforms_iterate waveform WHEN condition
	| conditional_waveforms_iterate waveform
	;

conditional_waveforms_iterate
	: //empty
	| conditional_waveforms_iterate waveform WHEN condition ELSE
	;


/********** Selected signal assignments **********/

selected_signal_assignment
	: WITH expression SELECT target LESS_THAN_OR_EQUAL options selected_waveforms ';'
	;

selected_waveforms
	: waveform WHEN choices
	| selected_waveforms ',' waveform WHEN choices
	;



/********************************** Component instantiation statements **********************************/

component_instantiation_statement
	: label ':'
	    instantiated_unit
	      component_instantiation_statement_generic_map_aspect_optional
	      component_instantiation_statement_port_map_aspect_optional ';'
	;

component_instantiation_statement_generic_map_aspect_optional
	: //empty
	| generic_map_aspect
	;

component_instantiation_statement_port_map_aspect_optional
	: //empty
	| port_map_aspect
	;

instantiated_unit
	: name
	| COMPONENT name
	| ENTITY name
	| ENTITY name '(' identifier ')'
	| CONFIGURATION name
	;



/********************************** Generate statements **********************************/

generate_statement
	: label ':'
	    generation_scheme GENERATE
		generate_statement_block_declarative_item_begin_optional
	      generate_statement_concurrent_statement_iterate
	    END GENERATE generate_statement_label_optional ';'
	;

generate_statement_block_declarative_item_begin_optional
	: //empty
	| generate_statement_block_declarative_item_iterate BEGIN
	;

generate_statement_block_declarative_item_iterate
	: //empty
	| generate_statement_block_declarative_item_iterate block_declarative_item
	;

generate_statement_concurrent_statement_iterate
	: //empty
	| generate_statement_concurrent_statement_iterate concurrent_statement
	;

generate_statement_label_optional
	: //empty
	| label
	;

generation_scheme
	: FOR parameter_specification
	| IF condition
	;

label
	: identifier
	;





/*#####################################################
  #                Scope and visibility               #
  #####################################################*/


/********************************** Use clauses **********************************/

use_clause
	: USE selected_name selected_name_iterate ';'
	;

selected_name_iterate
	: //empty
	| selected_name_iterate ',' selected_name
	;





/*#####################################################
  #          Design units and their analysis          #
  #####################################################*/


/********************************** Design units **********************************/

design_file
	: design_unit
	| design_file design_unit
	;

design_unit
	: context_clause library_unit
	;

library_unit
	: primary_unit
	| secondary_unit
	;

primary_unit
	: entity_declaration
	| configuration_declaration
	| package_declaration
	;

secondary_unit
	: architecture_body
	| package_body
	;


/********************************** Design libraries **********************************/

library_clause
	: LIBRARY logical_name_list ';'
	;

logical_name_list
	: logical_name
	| logical_name_list ',' logical_name
	;

logical_name
	: identifier
	;


/********************************** Context clauses **********************************/

context_clause
	: //empty
	| context_clause context_item
	;

context_item
	: library_clause
	| use_clause
	;






/*#####################################################
  #                    Common rules                   #
  #####################################################*/

architecture_optional
	: //empty
	| ARCHITECTURE
	;

entity_optional
	: //empty
	| ENTITY
	;

simple_name_optional
	: //empty
	| simple_name
	;

configuration_optional
	: //empty
	| CONFIGURATION
	;

package_optional
	: //empty
	| PACKAGE
	;

is_optional
	: //empty
	| IS
	;

postponed_optional
	: //empty
	| POSTPONED
	;

identifier
	: BASIC_IDENTIFIER
	| EXTENDED_IDENTIFIER
	;

